import {system, world} from '@minecraft/server';
function replaceEmojis(inputString, emojiReplacements) {
    let replacedString = inputString;
    for (const emoji in emojiReplacements) {
      const emojiPattern = new RegExp(`:${emoji}:`, 'g');
      replacedString = replacedString.replace(emojiPattern, emojiReplacements[emoji]);
    }
    return replacedString;
}
function convertToEmoji(input) {
    let output = String.fromCodePoint(parseInt("0xE1"+input, 16));
    return output;
};
let emojiIndex = 0;
const first = ["1", "2", "3", "4", "5", "6", "7", "8", "9", "A", "B", "C", "D", "E", "F"];
const second = ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "A", "B", "C", "D", "E", "F"];
let emojiReplacements = {};
let emojiArray = [];
const emojiNamespace = ["smile", "broad smile", "laugh", "awkward laugh", "lmao", "joy", "grin", "upsidedown smile", "creepy smile", "eyes", "melting", "wink", "satisfied", "angel", "adoring smile", "loving smile", "friendly smile", "love kiss", "kiss", "proud smile", "expressionless", "smile with tear", "yummy", "exited smile", "joke", "lol", "tongue smile", "greedy smile", "happy smile", "grin with eyebrows", "what", "shush", "sad", "ayo", "zipper mouth", "eye bag", "no mouth", "face in cloud", "smirk", "rolling eyes", "grimace", "sleep", "liar", "surprised", "tired grin", "snooze", "drool", "uwu", "mask", "angry look", "unphased", "sick", "throwup", "sneeze", "hot", "ice cold", "weird wink", "dead", "dizzy", "mind blowing", "yehaw", "partying", "disguised", "cool", "nerd", "monocle", "slightly sad", "erm", "emotionless", "almost sad", "sad", ":0", "woah", "0_0", "frown left", "frown right", "fearful", "fearful sweat", "sweating", "sobbing tear", "cry", "persevere", "speechless", "yawn", "very angry", "angry", "devil smile", "devil angry", "skull", "poop", "clown", "cat cry", "cat smile", "cat laugh", "cat loving eyes", "cat wink", "ghost", "alien", "love letter", "heartstruck", "gifted heart", "heart", "shining heart", "hearts", "broken heart", "healing heart"];
function assignEmoji() {
    for (let f = 0; f < first.length; f++) {
        for (let s = 0; s < second.length; s++) {
            let indexValue = first[f] + second[s];
            emojiReplacements[emojiNamespace[emojiIndex]] = convertToEmoji(indexValue);
            emojiArray[emojiIndex] = convertToEmoji(indexValue);
            emojiIndex++;
        }
    }
}
assignEmoji();
world.beforeEvents.chatSend.subscribe((event)=> {
    const player = event.sender;
    event.cancel = true;
    let filterMessage = replaceEmojis(event.message, emojiReplacements);
    const keywordPattern = /emoji:(\d+)/;
    const match = event.message.match(keywordPattern);
    if (match) {
        const value = parseInt(match[1], 10) - 1;
        if (value > 10) {
            player.sendMessage("There's only 11 suggestion pages")
        } else {
            player.sendMessage("");
            for (let i = value*10; i < (value+1)*10; i++) {
                if (emojiNamespace[i]) {
                    player.sendMessage(`:${emojiNamespace[i]}: ${emojiArray[i]}`)
                }
        }}
        
    } else {player.runCommandAsync(`say ${filterMessage}`)};
});
system.runInterval(
    () => {
        world.getAllPlayers().forEach(
            (player) => {
                if (player) {
                    let blockLookAt = player.getBlockFromViewDirection()?.block
                    if (blockLookAt) {
                        let previousTextSign = blockLookAt?.getComponent("minecraft:sign")?.getText();
                        if (previousTextSign) {
                            blockLookAt?.getComponent("minecraft:sign")?.setText(replaceEmojis(previousTextSign, emojiReplacements));
                        }
                    };
                    let heldItem = player.getComponent("minecraft:inventory")?.container?.getItem(player?.selectedSlot);
                    if (heldItem) {
                        const inv = player.getComponent("minecraft:inventory")?.container;
                        const heldItem = inv.getItem(player?.selectedSlot);
                        let previousName = heldItem.nameTag;
                        if (previousName) {
                            heldItem.nameTag = replaceEmojis(previousName, emojiReplacements);
                            inv.setItem(player?.selectedSlot, heldItem)
                        }
                    }
                };
            },
        );
    },
);